package com.hzya.frame.nifiapi.operation.impl;

import cn.hutool.core.util.StrUtil;
import com.hzya.frame.nifiapi.config.NifiServiceConfig;
import com.hzya.frame.nifiapi.model.joinbindparametercontexts.BindParameterContextsJoin11;
import com.hzya.frame.nifiapi.model.joinbindparametercontexts.Component11;
import com.hzya.frame.nifiapi.model.joinbindparametercontexts.ParameterContext11;
import com.hzya.frame.nifiapi.model.joinbindparametercontexts.Revision11;
import com.hzya.frame.nifiapi.model.joincreparamcontext.CreateParamContextJoin;
import com.hzya.frame.nifiapi.model.joinfindneedmodifycontroller.FindNeedModifyController;
import com.hzya.frame.nifiapi.model.joingetallcontrollerservice.ControllerServices19;
import com.hzya.frame.nifiapi.model.joingetallcontrollerservice.GetAllController19;
import com.hzya.frame.nifiapi.model.joingetcontroller.ControllerService12;
import com.hzya.frame.nifiapi.model.joingetcontroller.Revision12;
import com.hzya.frame.nifiapi.model.joinparametercontexts.*;
import com.hzya.frame.nifiapi.model.joinsnippetinstance.SnippetInstanceJoin;
import com.hzya.frame.nifiapi.model.joinsnippets.Snippet;
import com.hzya.frame.nifiapi.model.joinsnippets.SnippetsJoin;
import com.hzya.frame.nifiapi.model.resultcreatesnippet.Flow15;
import com.hzya.frame.nifiapi.model.resultcreatesnippet.ProcessGroups15;
import com.hzya.frame.nifiapi.model.resultcreatesnippet.SnippetInstance15;
import com.hzya.frame.nifiapi.model.resultparametercontexts.ParameterContextsResult;
import com.hzya.frame.nifiapi.model.resultprocessgroupsinfo.ProcessGroupsInfoResult9;
import com.hzya.frame.nifiapi.model.resultprocessgroupsinfo.Revision9;
import com.hzya.frame.nifiapi.model.resultsnippets.Snippet13;
import com.hzya.frame.nifiapi.model.resultsnippets.SnippetResult13;
import com.hzya.frame.nifiapi.operation.IBaseOperation;
import com.hzya.frame.nifiapi.service.NifiApiService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Author：liuyang
 * @Package：com.hzya.frame.nifiapi.operation.impl
 * @Project：fw-nifi
 * @name：BaseOperationImpl
 * @Date：2025/5/21 18:07
 * @Filename：BaseOperationImpl
 */
@Repository(value = "BaseOperationImpl")
public class BaseOperationImpl implements IBaseOperation {

    Logger logger = LoggerFactory.getLogger(BaseOperationImpl.class);

    @Autowired
    private NifiApiService nifiApiService;

    @Autowired
    private NifiServiceConfig nifiServiceConfig;

    @Override
    public String instantiateApp(String appProcessGroupId, String parentProcessGroupId, String copyTargetProcessGroupId) throws Exception {
        String processGroups15Id = null;
        try {
            //创建流程组片段
            //查询目标流程组版本
            ProcessGroupsInfoResult9 processGroups = nifiApiService.getProcessGroups(appProcessGroupId);
            Revision9 revision = processGroups.getRevision();

            Map<String, String> processGroupsMap2 = new HashMap<>();
            processGroupsMap2.put("version", revision.getVersion());//目标流程组版本号

            Map<String, Map<String, String>> processGroupsMap = new HashMap<>();
            processGroupsMap.put(appProcessGroupId, processGroupsMap2);//目标流程组id

            Snippet snippet = new Snippet();
            snippet.setParentGroupId(parentProcessGroupId);//目标流程组id的父流程组id
            snippet.setProcessGroups(processGroupsMap);

            SnippetsJoin snippetsJoin = new SnippetsJoin();
            snippetsJoin.setSnippet(snippet);
            SnippetResult13 snippets = nifiApiService.createSnippets(snippetsJoin);
            Snippet13 snippet1 = snippets.getSnippet();

            //2.将片段实例化到指定位置,得到实例化后的应用id
            ProcessGroupsInfoResult9 processGroups2 = nifiApiService.getProcessGroups(copyTargetProcessGroupId);
            Revision9 revision2 = processGroups2.getRevision();

            Map<String, String> processGroupsMap3 = new HashMap<>();
            processGroupsMap3.put("version", revision2.getVersion());//目标流程组版本号

            Map<String, Map<String, String>> processGroupId = new HashMap<>();
            processGroupId.put(copyTargetProcessGroupId, processGroupsMap3);//目标流程组id

            SnippetInstanceJoin snippetInstanceJoin = new SnippetInstanceJoin();
            snippetInstanceJoin.setSnippetId(snippet1.getId());
            SnippetInstance15 snippetInstance = nifiApiService.createSnippetInstance(copyTargetProcessGroupId, snippetInstanceJoin);
            Flow15 flow = snippetInstance.getFlow();
            ProcessGroups15 processGroups15 = flow.getProcessGroups().get(0);
            processGroups15Id = processGroups15.getId();
        } catch (Exception e) {
            throw new Exception(e);
        }
        return processGroups15Id;
    }

    @Override
    public String createParameterContextsBindingProcessGroup(CreateParamContextJoin createParamContextJoin) throws Exception {
        String paramGroupsId = null;
        try {
            //1.创建参数上下文
            ParameterContextsJoin parameterContextsJoin1 = createParamContextJoin.getParameterContextsJoin();
            ParameterContextsResult parameterContexts = nifiApiService.createParameterContexts(parameterContextsJoin1);
            System.out.println(parameterContexts);

            //2.绑定到指定流程组
            //查询指定流程组的详情
            String processGroupsId = createParamContextJoin.getProcessGroupsId();
            ProcessGroupsInfoResult9 processGroups = nifiApiService.getProcessGroups(processGroupsId);
            Revision9 revision = processGroups.getRevision();

            //流程组的版本号
            Revision11 revision11 = new Revision11();
            revision11.setVersion(revision.getVersion());

            //参数上下文对象id
            ParameterContext11 parameterContext11 = new ParameterContext11();
            parameterContext11.setId(parameterContexts.getId());

            //指定的组件对象
            Component11 component11 = new Component11();
            component11.setId(processGroups.getId());
            component11.setParameterContext(parameterContext11);

            BindParameterContextsJoin11 bindParameterContextsJoin11 = new BindParameterContextsJoin11();
            bindParameterContextsJoin11.setComponent(component11);
            bindParameterContextsJoin11.setRevision(revision11);
            ProcessGroupsInfoResult9 processGroupsInfoResult9 = nifiApiService.bindParameterContexts(bindParameterContextsJoin11);
            logger.info("流程组id:{}", processGroupsInfoResult9.getId());
            paramGroupsId = parameterContexts.getId();
        } catch (Exception e) {
            throw new Exception(e);
        }
        return paramGroupsId;
    }

    @Override
    public List<ControllerServices19> getNeedModifyControllerServicesByProcessGroup(String processGroupId) throws Exception {
        String controllerModifyMark = nifiServiceConfig.getControllerModifyMark();
        //1.查找某个流程组内的所有控制器，筛选出带"接口修改标记"的控制器，片段
        List<ControllerServices19> modifiedControllers = new ArrayList<>();
        GetAllController19 allControllerServices = nifiApiService.getAllControllerServices(processGroupId);
        if (allControllerServices != null && allControllerServices.getControllerServices() != null) {
            modifiedControllers = allControllerServices.getControllerServices().stream().filter(service -> service.getComponent() != null && controllerModifyMark.equals(service.getComponent().getComments())).collect(Collectors.toList());
        }
        return modifiedControllers;
    }

    @Override
    public void findNeedModifyControllerAndChangesOccur(FindNeedModifyController findNeedModifyController, boolean isThrowError) throws Exception {
        try {
            //1.得到"接口修改标记"的控制器，并验证入参数量是否匹配
            List<ControllerServices19> needModifyControllerServicesByProcessGroup = getNeedModifyControllerServicesByProcessGroup(findNeedModifyController.getProcessGroupId());

            List<ControllerService12> needModifyController = findNeedModifyController.getNeedModifyController();
            if (needModifyControllerServicesByProcessGroup != null) {
                if ((needModifyControllerServicesByProcessGroup.size() != needModifyController.size()) && isThrowError) {
                    throw new Exception(StrUtil.format("需要接口修改{}个控制器，但接口传了{}个", needModifyControllerServicesByProcessGroup.size(), needModifyController.size()));
                }
            }

            //2.修改指定控制器
            for (ControllerService12 controllerService11 : needModifyController) {
                //查询控制器版本
                ControllerService12 controllerServices = nifiApiService.getControllerServices(controllerService11.getId());
                Revision12 revision = controllerServices.getRevision();

                Revision12 revision12 = new Revision12();
                revision12.setVersion(revision.getVersion());

                controllerService11.setRevision(revision12);
                ControllerService12 controllerService12 = nifiApiService.updateControllerServices(controllerService11.getId(), controllerService11);
                //在传参没有问题的情况下，有控制器id返回即代表修改成功
                logger.info("控制器id:{}", controllerService12.getId());
            }
        } catch (Exception e) {
            throw new Exception(e);
        }
    }
}
